Index: code/branches/kicklib/src/libraries/core/GUIManager.cc
===================================================================
--- code/branches/kicklib/src/libraries/core/GUIManager.cc	(revision 7965)
+++ code/branches/kicklib/src/libraries/core/GUIManager.cc	(revision 7967)
@@ -46,5 +46,5 @@
 #include <elements/CEGUIListboxItem.h>
 
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
 #  include <CEGUILua.h>
 #  include <ogreceguirenderer/OgreCEGUIRenderer.h>
@@ -93,5 +93,5 @@
                 case CEGUI::Informative: orxonoxLevel = 5; break;
                 case CEGUI::Insane:      orxonoxLevel = 6; break;
-                default: OrxAssert(false, "CEGUI log level out of range, inpect immediately!");
+                default: OrxAssert(false, "CEGUI log level out of range, inspect immediately!");
             }
             OutputHandler::getOutStream(orxonoxLevel)
@@ -127,5 +127,5 @@
         , guiSystem_(NULL)
         , resourceProvider_(NULL)
-#if CEGUI_VERSION_MAJOR >= 1 || CEGUI_VERSION_MINOR >= 7
+#ifdef CEGUI_OLD_VERSION
         , imageCodec_(NULL)
 #endif
@@ -140,5 +140,5 @@
 
         // Note: No SceneManager specified yet
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         guiRenderer_ = new OgreCEGUIRenderer(GraphicsManager::getInstance().getRenderWindow(), Ogre::RENDER_QUEUE_OVERLAY, false, 3000);
         resourceProvider_ = guiRenderer_->createResourceProvider();
@@ -155,5 +155,5 @@
         // This is necessary to ensure that input events also use the right resource info when triggering lua functions
         luaState_->setDefaultResourceInfo(this->rootFileInfo_);
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         scriptModule_ = new LuaScriptModule(luaState_->getInternalLuaState());
 #else
@@ -171,5 +171,5 @@
 
         // Create the CEGUI system singleton
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         guiSystem_ = new System(guiRenderer_, resourceProvider_, 0, scriptModule_);
         // Add functions that have been renamed in newer versions
@@ -207,5 +207,5 @@
         using namespace CEGUI;
 
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         delete guiSystem_;
         delete guiRenderer_;
@@ -260,5 +260,5 @@
     {
         this->camera_ = camera;
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         if (camera == NULL)
             this->guiRenderer_->setTargetSceneManager(0);
@@ -539,5 +539,5 @@
         The Listbox for which to enable (or disable) tooltips.
     @param enabled
-        Whether to enable or disabel the tooltips.
+        Whether to enable or disable the tooltips.
     */
     void GUIManager::setItemTooltipsEnabledHelper(CEGUI::Listbox* listbox, bool enabled)
@@ -551,5 +551,5 @@
     void GUIManager::windowResized(unsigned int newWidth, unsigned int newHeight)
     {
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         this->guiRenderer_->setDisplaySize(CEGUI::Size(newWidth, newHeight));
 #else
@@ -559,5 +559,5 @@
 
     /**
-        @brief Notify CEGUI if the windows loses the focus (stops higlight of menu items, etc).
+        @brief Notify CEGUI if the windows loses the focus (stops highlight of menu items, etc).
     */
     void GUIManager::windowFocusChanged(bool bFocus)
Index: code/branches/kicklib/src/libraries/core/GUIManager.h
===================================================================
--- code/branches/kicklib/src/libraries/core/GUIManager.h	(revision 7965)
+++ code/branches/kicklib/src/libraries/core/GUIManager.h	(revision 7967)
@@ -57,4 +57,8 @@
 $cfile "../util/TriBool.h" // tolua_export
 */
+
+#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#  define CEGUI_OLD_VERSION
+#endif
 
 namespace orxonox // tolua_export
@@ -149,5 +153,5 @@
         Loki::ObjScopeGuardImpl0<GUIManager, void (GUIManager::*)()> destroyer_;
 
-#if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
+#ifdef CEGUI_OLD_VERSION
         CEGUI::OgreCEGUIRenderer*            guiRenderer_;      //!< CEGUI's interface to the Ogre Engine
         CEGUI::ResourceProvider*             resourceProvider_; //!< CEGUI's resource provider