Index: /code/branches/usability/src/modules/objects/triggers/DistanceMultiTrigger.cc
===================================================================
--- /code/branches/usability/src/modules/objects/triggers/DistanceMultiTrigger.cc	(revision 7977)
+++ /code/branches/usability/src/modules/objects/triggers/DistanceMultiTrigger.cc	(revision 7978)
@@ -54,5 +54,5 @@
 
         this->distance_ = 100.0f;
-        this->targetName_ = BLANKSTRING;
+        this->targetName_ = "";
         this->singleTargetMode_ = false;
     }
@@ -181,5 +181,5 @@
     {
         // If the targetname is no blank string single-target mode is enabled.
-        if(targetname.compare(BLANKSTRING) != 0)
+        if(targetname != "")
             this->singleTargetMode_ = true;
         else
Index: /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.cc
===================================================================
--- /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.cc	(revision 7977)
+++ /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.cc	(revision 7978)
@@ -50,5 +50,5 @@
     this->distance_ = 100;
     this->targetMask_.exclude(Class(BaseObject));
-    this->targetName_ = BLANKSTRING;
+    this->targetName_ = "";
     this->singleTargetMode_ = false;
   }
Index: /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.h
===================================================================
--- /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.h	(revision 7977)
+++ /code/branches/usability/src/modules/objects/triggers/DistanceTrigger.h	(revision 7978)
@@ -70,5 +70,5 @@
 
       inline void setTargetName(const std::string& targetname)
-        { if(targetname.compare(BLANKSTRING) != 0) this->singleTargetMode_ = true; else this->singleTargetMode_ = false; this->targetName_ = targetname; }
+        { if(targetname != "") this->singleTargetMode_ = true; else this->singleTargetMode_ = false; this->targetName_ = targetname; }
       inline const std::string& getTargetName(void)
         { return this->targetName_; }
Index: /code/branches/usability/src/modules/pickup/PickupRepresentation.cc
===================================================================
--- /code/branches/usability/src/modules/pickup/PickupRepresentation.cc	(revision 7977)
+++ /code/branches/usability/src/modules/pickup/PickupRepresentation.cc	(revision 7978)
@@ -156,5 +156,5 @@
         {
             COUT(4) << "PickupRepresentation: No spawner representation found." << std::endl;
-            if(this->spawnerTemplate_ == BLANKSTRING)
+            if(this->spawnerTemplate_ == "")
             {
                 COUT(4) << "PickupRepresentation: Spawner template is empty." << std::endl;
Index: /code/branches/usability/src/modules/questsystem/effects/AddQuestHint.cc
===================================================================
--- /code/branches/usability/src/modules/questsystem/effects/AddQuestHint.cc	(revision 7977)
+++ /code/branches/usability/src/modules/questsystem/effects/AddQuestHint.cc	(revision 7978)
@@ -86,5 +86,5 @@
     bool AddQuestHint::setHintId(const std::string & id)
     {
-        if(id.compare(BLANKSTRING) == 0)
+        if(id == "")
         {
             COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
Index: /code/branches/usability/src/modules/questsystem/effects/ChangeQuestStatus.cc
===================================================================
--- /code/branches/usability/src/modules/questsystem/effects/ChangeQuestStatus.cc	(revision 7977)
+++ /code/branches/usability/src/modules/questsystem/effects/ChangeQuestStatus.cc	(revision 7978)
@@ -81,5 +81,5 @@
     bool ChangeQuestStatus::setQuestId(const std::string & id)
     {
-        if(id.compare(BLANKSTRING) == 0)
+        if(id == "")
         {
             COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
Index: /code/branches/usability/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- /code/branches/usability/src/orxonox/gamestates/GSLevel.cc	(revision 7977)
+++ /code/branches/usability/src/orxonox/gamestates/GSLevel.cc	(revision 7978)
@@ -55,5 +55,5 @@
 
     SetConsoleCommand(__CC_startMainMenu_name, &GSLevel::startMainMenu).deactivate();
-    SetConsoleCommand(__CC_changeGame_name, &GSLevel::changeGame).defaultValues(BLANKSTRING).deactivate();
+    SetConsoleCommand(__CC_changeGame_name, &GSLevel::changeGame).defaultValues("").deactivate();
 
     GSLevel::GSLevel(const GameStateInfo& info)
@@ -202,5 +202,5 @@
     /*static*/ void GSLevel::changeGame(const std::string& level)
     {
-        if(level != BLANKSTRING)
+        if(level != "")
             LevelManager::getInstance().setDefaultLevel(level);
 
Index: /code/branches/usability/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/branches/usability/src/orxonox/gamestates/GSMainMenu.cc	(revision 7977)
+++ /code/branches/usability/src/orxonox/gamestates/GSMainMenu.cc	(revision 7978)
@@ -57,8 +57,8 @@
     static const std::string __CC_setMainMenuSoundPath_name = "setMMSoundPath";
 
-    SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).defaultValues(BLANKSTRING).deactivate();
-    SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).defaultValues(BLANKSTRING).deactivate();
-    SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).defaultValues(BLANKSTRING).deactivate();
-    SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).defaultValues(BLANKSTRING).deactivate();
+    SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).defaultValues("").deactivate();
+    SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).defaultValues("").deactivate();
+    SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).defaultValues("").deactivate();
+    SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).defaultValues("").deactivate();
     SetConsoleCommand(__CC_setMainMenuSoundPath_name, &GSMainMenu::setMainMenuSoundPath).hide();
 
@@ -176,5 +176,5 @@
     void GSMainMenu::startStandalone(const std::string& level)
     {
-        if(level != BLANKSTRING)
+        if(level != "")
             LevelManager::getInstance().setDefaultLevel(level);
 
@@ -192,5 +192,5 @@
     void GSMainMenu::startServer(const std::string& level)
     {
-        if(level != BLANKSTRING)
+        if(level != "")
             LevelManager::getInstance().setDefaultLevel(level);
 
@@ -208,5 +208,5 @@
     void GSMainMenu::startClient(const std::string& destination)
     {
-        if(destination != BLANKSTRING)
+        if(destination != "")
             Client::getInstance()->setDestination(destination, NETWORK_PORT);
 
@@ -224,5 +224,5 @@
     void GSMainMenu::startDedicated(const std::string& level)
     {
-        if(level != BLANKSTRING)
+        if(level != "")
             LevelManager::getInstance().setDefaultLevel(level);
 
Index: /code/branches/usability/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- /code/branches/usability/src/orxonox/gamestates/GSMainMenu.h	(revision 7977)
+++ /code/branches/usability/src/orxonox/gamestates/GSMainMenu.h	(revision 7978)
@@ -53,8 +53,8 @@
         void setMainMenuSoundPath(const std::string& path);
 
-        static void startStandalone(const std::string& level = BLANKSTRING); //!< Start a level in standalone mode.
-        static void startServer(const std::string& level = BLANKSTRING); //!< Start a level in server mode.
-        static void startClient(const std::string& destination = BLANKSTRING); //!< Connect to a game as client.
-        static void startDedicated(const std::string& level = BLANKSTRING); //!< Start a level in dedicated mode.
+        static void startStandalone(const std::string& level = ""); //!< Start a level in standalone mode.
+        static void startServer(const std::string& level = ""); //!< Start a level in server mode.
+        static void startClient(const std::string& destination = ""); //!< Connect to a game as client.
+        static void startDedicated(const std::string& level = ""); //!< Start a level in dedicated mode.
         static void startIOConsole();
 