Index: branches/gui/src/lib/gui/gl_gui/signal_connector.cc
===================================================================
--- branches/gui/src/lib/gui/gl_gui/signal_connector.cc	(revision 7993)
+++ branches/gui/src/lib/gui/gl_gui/signal_connector.cc	(revision 7994)
@@ -62,4 +62,9 @@
   }
 
+  /**
+   * @brief assignes a SignalConnector to the current one
+   * @param signalConnector the SignalConnector to assign to this one
+   * @return A Reference to this SignalConnector.
+   */
   SignalConnector& SignalConnector::operator=(const SignalConnector& signalConnector)
   {
@@ -67,4 +72,15 @@
     this->object = signalConnector.object;
     this->exec = (signalConnector.exec == NULL) ? NULL : signalConnector.exec->clone();
+  }
+
+
+  /**
+   * @brief compares two SignalConnectors.
+   * @param signalConnector the SignalConnector to compare against this one.
+   * @return true if the Connectors are the same.
+   */
+  bool SignalConnector::operator==(const SignalConnector& signalConnector) const
+  {
+    return (this->object == signalConnector.object /* && this->exec == signalConnector.exec */ );
   }
 
Index: branches/gui/src/lib/gui/gl_gui/signal_connector.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/signal_connector.h	(revision 7993)
+++ branches/gui/src/lib/gui/gl_gui/signal_connector.h	(revision 7994)
@@ -158,5 +158,5 @@
 
     SignalConnector& operator=(const SignalConnector& signalConnector);
-    bool operator==(const SignalConnector& signalConnector);
+    bool operator==(const SignalConnector& signalConnector) const;
 
     void operator()() const;
Index: branches/gui/src/lib/util/executor/executor.h
===================================================================
--- branches/gui/src/lib/util/executor/executor.h	(revision 7993)
+++ branches/gui/src/lib/util/executor/executor.h	(revision 7994)
@@ -42,4 +42,5 @@
 
     virtual Executor* clone () const = 0;
+//    virtual bool operator==(const Executor* executor) const = 0;
 
     // SETTING up the EXECUTOR
@@ -51,6 +52,6 @@
 
     // EXECUTE
+    /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
     virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const = 0;
-
     /** executes a Command @param object the object to apply this to @param parameters the parameters the command takes */
     virtual void operator()(BaseObject* object, const SubString& sub = SubString()) const = 0;
Index: branches/gui/src/lib/util/executor/executor_functional.cc
===================================================================
--- branches/gui/src/lib/util/executor/executor_functional.cc	(revision 7993)
+++ branches/gui/src/lib/util/executor/executor_functional.cc	(revision 7994)
@@ -40,5 +40,5 @@
 template<> float fromMulti<float>(const MultiType& multi) { return multi.getFloat(); };
 template<> char fromMulti<char>(const MultiType& multi) { return multi.getChar(); };
-template<> const std::string& fromMulti<const std::string&>(const MultiType& multi) { return multi.getString(); };
+template<> const std::string& fromMulti<const std::string&>(const MultiType& multi) { return multi.getConstString(); };
 
 
Index: branches/gui/src/lib/util/executor/executor_functional.h
===================================================================
--- branches/gui/src/lib/util/executor/executor_functional.h	(revision 7993)
+++ branches/gui/src/lib/util/executor/executor_functional.h	(revision 7994)
@@ -122,4 +122,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
@@ -161,4 +162,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
@@ -223,4 +225,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
@@ -276,4 +279,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
@@ -332,4 +336,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
@@ -390,4 +395,5 @@
   };
 
+  /** executes a Command. @param objec the Object, @param count how many values, @param values the Values */
   virtual void operator()(BaseObject* object, unsigned int count, const MultiType* values) const
   {
Index: branches/gui/src/lib/util/multi_type.cc
===================================================================
--- branches/gui/src/lib/util/multi_type.cc	(revision 7993)
+++ branches/gui/src/lib/util/multi_type.cc	(revision 7994)
@@ -381,4 +381,11 @@
 }
 
+const std::string& MultiType::getConstString() const
+{
+  MultiType::constString = this->getString();
+  return MultiType::constString;
+}
+
+
 /**
  * @returns a formated c-string of the held value
@@ -490,4 +497,5 @@
 
 
+std::string MultiType::constString = "";
 const std::string MultiType::typeNames[] =
   {
Index: branches/gui/src/lib/util/multi_type.h
===================================================================
--- branches/gui/src/lib/util/multi_type.h	(revision 7993)
+++ branches/gui/src/lib/util/multi_type.h	(revision 7994)
@@ -87,4 +87,5 @@
     const char* getCString();
     std::string getString() const;
+    const std::string& getConstString() const;
 
     void reset();
@@ -107,4 +108,7 @@
     MT_Type                      type;              //!< The Type stored in this MultiType
 
+
+    static std::string           constString;       //!< A String for returning Constant strings.
+
     static const std::string     typeNames[];       //!< List of TypeNames for conversion.
 };